;
;       @MBS  {Tu[`
;
TMR_01M               ;  bnk2
    MOVF    KEITIM,W   ; TIMSA ==KEIKTM
    ADDWF   TIM10C,F
    MOVF    KEITIM+1,W
    ADDWFC  TIM10C+1,F

    MOVLW   50        ; 50mS
    SUBWF   TIM10C,W
    BNC     TM_CAL1   ;  C =1 ->TIM10C >=50
    BRA     TM_CAL5
TM_CAL1
    MOVF    TIM10C +1,W
    BZ      TIM_S0R

TM_CAL5
    CLRoF   Q0L
    MOVFF   TIM10C,TMPL
    MOVFF   TIM10C+1,TMPH
TIM_CGR
    MOVLW   50        ; 50mS
    SUBWF   TMPL,F    ; TIM10C
    CLRF    WREG
    BC      TM_CAL4
    INCF    WREG,W    ; C =0 ->TIM10C <50\n"
TM_CAL4
    SUBWF   TMPH,F    ; TIM10C +1
    BC      TM_CAL2
    BRA     TM_CAL3
TM_CAL2
    INCoFF  Q0L       ; 50mS +1(±ٶ->Q0L) 1 ]]
    MOVFF   TMPL,TIM10C    ; AMARI
    MOVFF   TMPH,TIM10C+1  ; AMARI
    BRA     TIM_CGR
TM_CAL3
    CALL    TIM_DECR
    DECoFSZF Q0L
    BRA     TM_CAL3  ;^^^^^^^^

TIM_S0R
    RETURN

;------------------        ---------------------
TIM_DECR               ;  bnk2
    MOVLW   01H
    MOVWF   TMPH
    INCF    TIM50C,F

    BTFSS   INITMF,5
    BRA     TIM_NOM    ; -ς

    BTFSC   TIM50C,0
    BRA     TIM_S2    ; 50 & NON-100
    MOVLW   03H
    MOVWF   TMPH
TIM_S1
    MOVLW   10    ; 0.5-SEC
    SUBWF   TIM50C,W
    BTFSS   STATUS,C    ; C=1  TIM_10C >=10
    BRA     TIM_S2
    CLRF    TIM50C
    MOVLW   07H
    MOVWF   TMPH
TIM_S2
    MOVF    TMPH,W
    XORWF   TOKREG+1,F
                       ;|/ }100mS 100mSP
;-----------  100mS P     ---------
TIM_NOM               ;  bnk2
    INCF    NOMTMX,W   ; 0 ->1
    BZ      TIM_0R     ; ς

    MOVoWFF Q1L        ; ό

    LFSR    0,TCRAM      ; BNK4 ڽ@{lݒ
    LFSRI2  TUSEBIT, HIGH TUSEBIT
    MOVLW   01
    MOVWF   REG1
TIM_K2
    FSR_FS2
    MOVF    INDF0,W
    FSR_FS0
    ANDWF   REG1,W
    BZ      TM_ROT
    MOVF    POSTINC0,W
    IORWF   POSTDEC0,W
    BZ      TM_ROT       ; e =0

    CALL    WORDDEC      ; 50ms-1
    DECF    FSR0L,F

TM_ROT
    BCF     STATUS,C
    RLCF    REG1,F       ; BIT
    BNC     TM_R02
    MOVLW   01           ; <D7>=1 ޯ
    MOVWF   REG1
    FSR_FS2
    INCF    FSR0L
    FSR_FS0
TM_R02
    DCoFSNZF Q1L         ; ϐ
    BRA     TIM_0R

    INCF    FSR0L,F
    INCF    FSR0L,F
    BRA     TIM_K2     ; NEXT-TIMER^^^^^^^^^^^^^
TIM_0R
    RETURN 

;---------------------------------------------------
POT_INP               ;  bnk2
    MOVFF   PORTA,F1SR
    MOVFF   PORTB,F2SR
    MOVFF   PORTC,F3SR
    MOVFF   PORTD,FLAG1
    MOVFF   PORTE,Q0L

    ;BNK2 
    MOVLW   TRIACO
    ANDWF   SETTNXY +0*2,F    ;  PIN   0 

    COMF    F1SR,W    ; F1SR =PORTA   PIN  0  1
    ANDLW   TRIARM
    IORWF   SETTNXY +0*2,F

    MOVLW   TRIBCO
    ANDWF   SETTNXY +1*2,F    ;  PIN   0 

    COMF    F2SR,W        ; PORT_B  PIN  0  1
    ANDLW   TRIBRM
    IORWF   SETTNXY +1*2,F

    MOVLW   TRICCO
    ANDWF   SETTNXY +2*2,F    ;  PIN   0 

    COMF    F3SR,W        ; PORT_C  PIN  0  1
    ANDLW   TRICRM
    IORWF   SETTNXY +2*2,F

    MOVLW   TRIDCO
    ANDWF   SETTNXY +3*2,F ;  PIN   0 
;
    COMF    FLAG1,W        ; FLAG_1  PIN  0  1
    ANDLW   TRIDRM
    IORWF   SETTNXY +3*2,F

    MOVLW   TRIECO
    ANDWF   SETTNXY +4*2,F ;  PIN   0 
;
    COMoFW  Q0L            ; PORT_E  PIN  0  1
    ANDLW   TRIERM
    IORWF   SETTNXY +4*2,F

    RETURN

;---------------ȉ@Iyh-------------------

AXIXAND               ;  bnk2
    CLRWDT
    MOVF    AAX,W
    ANDWF   IIX,W
    RETURN


LOGINAX               ;  bnk2
    BCF     STATUS,C
    RLCF    LDLG,W
    IORWF   AAX,W
    MOVWF   LDLG
    RETURN


ANB               ;  bnk2
    MOVF    LDLG,W
    ANDLW   01
    ANDWF   AAX,F
    BRA     LD01
ORB
    MOVF    LDLG,W
    ANDLW   01
    IORWF   AAX,F
LD01
    BCF     STATUS,C
    RRCF    LDLG,F
    RETURN

;---------------------              ---------------------
MCROPE               ;  bnk2
    MOVF    TMPH,W     ; 0FC (MCR n2)
    IORWF   MCFLG,F    ; 0FD (MC n1 off)
    COMF    MCFLG,W    ;   2
    BTFSS   STATUS,Z
    BRA     MC0IIX
    BRA     MC1IIX

MCOPE
    CALL    AXIXAND
    BTFSC   STATUS,Z
    BRA     MCNOUT

    MOVF    MCFLG,W
    IORWF   CHSBIT,W
    BRA     MCNUK
MCNOUT
    MOVF    MCFLG,W
    COMF    CHSBIT,F
    ANDWF   CHSBIT,W
MCNUK
    MOVWF   MCFLG
    MOVWF   CHSBIT   ; temporary
IIXGR
    RRCF    CHSBIT,F ; to only cF
    BTFSS   STATUS,C
    BRA     MC0IIX

    DECF    TMPL,F   ; to only zF
    BTFSC   STATUS,Z
    BRA     MC1IIX
    BRA     IIXGR
MC1IIX
    MOVLW   01
    MOVWF   IIX
    RETURN
MC0IIX
    CLRF    IIX
    RETURN

;---------------       ---------------
JOUTOPE
    BTFSS   AAX,0
    RETURN

    MOVF    CHSBIT,W
    BRA     IND_NK       ; IRP BNK2,3 

;---------------       ---------------
OUTOPE               ;  bnk2
    BTFSS   AAX,0
    BRA     OF_OUT

    MOVF    INDF0,W
    IORWF   CHSBIT,W
    BRA     OUTNUK
OF_OUT
    MOVF    INDF0,W
    COMF    CHSBIT,F
    ANDWF   CHSBIT,W
OUTNUK
    BRA     IND_NK
;    MOVWF   INDF0

OUTDOPE
    BTFSS   AAX,0
    GOTO    SETD_OP
    COMF    CHSBIT,F
    GOTO    RSTD_OP

OUTDPOPE
    CALL    BIBCHK
    BTFSC   STATUS,Z
    CALL    OUTDOPE
    GOTO    STJOSET

;---------------------      -----------------------
SETOPE               ;  bnk2
    BTFSS   AAX,0
    RETURN
    MOVF    INDF0,W  ; SETTEN BNK2
    IORWF   CHSBIT, W   ; BNK0
    BRA    IND_NK
;    MOVWF   INDF0

SETDOPE
    BTFSS   AAX,0
    RETURN
SETD_OP
    CALL    DADR_CAL
    MOVF    CHSBIT,W
    IORWF   INDF0,F
    RETURN

SETPOPE
    CALL    BIBCHK
    BTFSC   STATUS,Z
    CALL    SETOPE
    GOTO    STJOSET

SETDPOPE
    CALL    BIBCHK
    BTFSC   STATUS,Z
    CALL    SETDOPE
    GOTO    STJOSET

;---------------------      -----------------------
RSTOPE               ;  bnk2
    BTFSS   AAX,0
    RETURN
    MOVF    INDF0,W
    COMF    CHSBIT,F
    ANDWF   CHSBIT,W
    BRA    IND_NK
;    MOVWF   INDF0

RSTDOPE
    BTFSS   AAX,0
    RETURN
RSTD_OP
    CALL    DADR_CAL
    MOVF    CHSBIT,W  ;  RS_TOPE OU_TOPE ޔ]
    ANDWF   INDF0,F
    RETURN

RSTPOPE
    CALL    BIBCHK
    BTFSC   STATUS,Z
    CALL    RSTOPE
    GOTO    STJOSET

RSTDPOPE
    CALL    BIBCHK
    BTFSC   STATUS,Z
    CALL    RSTDOPE
    GOTO    STJOSET

;---------------------      -----------------------
DADR_CAL
    MOVLW   SETTNXY
    SUBWF   FSR0L,W
    BCF     STATUS,C
    RRCF    WREG,W
    ADDLW   80H       ; PORTA_LOW  F80
    MOVWF   FSR0L
    MOVLW   0FH
    MOVWF   FSR0H
    RETURN

;---------------------      -----------------------
DADR_2CAL
    MOVLW   SETTNXY
    SUBWF   FSR02L,W
    BCF     STATUS,C
    RRCF    WREG,W
    ADDLW   80H       ; PORTA_LOW  F80
    MOVWF   FSR02L
    MOVLW   0FH
    MOVWF   FSR02H
    RETURN

;---------------------      -----------------------
PLSOPE
    CALL    BIBCHK
    BTFSS   STATUS,Z
    BRA     OFFOUT    ; MAE STJO SET SARETE IREBA off

    CALL    AXIXAND
    BTFSC   STATUS,Z
    BRA     OFFOUT
ONDOUT
    MOVF    INDF0,W
    IORWF   CHSBIT,W
    BRA     DF0NUK
OFFOUT                ; TSUMARI 1-puls  SINAI
    MOVF    INDF0,W
    COMF    CHSBIT,F
    ANDWF   CHSBIT,W
DF0NUK
    MOVWF    INDF0    ; ]]  INPUT
            ; ȉ VSTJO  KEEP
    GOTO    STJOSET


PLFOPE
    CALL    BIFCHK
    BTFSC   STATUS,Z
    GOTO    OFFOUT    ; MAE STJO SET SARETE INAKEREBA off
    CALL    AXIXAND
    BTFSS   STATUS,Z  ; x 0
                      ; x 1
    GOTO    OFFOUT    ; ^^^^^^
    GOTO    ONDOUT    ; ^^^^^^

;---------------------      -----------------------
BBAXCH ; TIMR ߂Ł@CALL 𽷯̂
    CALL    TMBBCHK   ; {݂̂ CALLED
    BTFSS   STATUS,Z
    BRA     BB2_0R    ; ̂̌AP Z !=1 CALL
        ; |/ MAE =0
    CALL    AXIXAND ; KONKAI  =0  ?
BB2_0R
    RETURN ; O=0 Z=1


;---------------------         -----------------------
TIMBOPE              ; !(!aax &&  !pr) BBAXCH omitt
TIM10MBOPE           ;  bnk2    bnk2׌Ă
    MOVLW   01
    MOVWF   REG2
    BRA     TIM_STA
TIMOPE               ; !(!aax &&  !pr) BBAXCH omitt
TIM10MOPE
    CLRF    REG2
TIM_STA
    CALL    TMBBCHK
    BTFSC   STATUS,Z
    BRA     TACCHTM  ;  aax &&  !pr

    MOVFF   FSR0L,F1SR  ; keep

    CALL    AXIXAND
    BTFSS   STATUS,Z
    BRA     VKEIZOK     ;       aax &&  pr
        ;|/   !aax &&  pr IKA  ω
;AXOFDAT
;   BNK2
    MOVLW   kiBSR
    MOVWF   FSR0H
    MOVFF   FSRCHN,FSR0L
    MOVF    INDF0,W
    COMF    CHSBIT,F
    ANDWF   CHSBIT,W
    MOVWF   INDF0

    MOVLW   1           ; 1st operand
    MOVWF   FSR0H      ; 1st -opera  timr( BNK-1 )
    MOVFF   F1SR,FSR0L  ; kept

TIM_CL0
    CLRF    POSTINC0   ; timr-KAI
    CLRF    INDF0      ; timr-JOI
    BRA     TIM0NK

TACCHTM              ; 
    CALL    BYT2FC2  ; =>TMPL, TMPH RE_G1 F1_SR FUSIYOU  FSR0H<-HENKA
    BTFSS   REG2,0
    CALL    BCDBIN   ; RE_G1 F1_SR FUSIYOU

    BTFSC   REG1,0   ; RE_G1 ώ preset
    BRA     TCM_02   ;  1m 
    BCF     STATUS,C
    RLCF    TMPL,F
    RLCF    TMPH,F   ; ρ@2{(50mSƌ)
TCM_02
    MOVFF   TMPL,POSTINC0
    MOVFF   TMPH,INDF0
    BRA     TIM0NK

VKEIZOK                ; INGA-volt  KEIZOKU
    MOVF    POSTINC0,W
    IORWF   POSTDEC0,W

    BTFSC   STATUS,Z
    BRA     VEND_0
    BRA     TIM0NK     ;> REG_1 TI_MOPEɓŕKSET
VEND_0
    MOVLW   kiBSR      ;BNK2
    MOVWF   FSR0H
    MOVFF   FSRCHN,FSR0L
    MOVF    INDF0,W
    IORWF   CHSBIT,W   ;  bnk2
IND_NK
    MOVWF   INDF0
TIM0NK
    RETURN               ; the END

;--------------------------------
CNTBOPE               ;  bnk2    bnk2׌Ă
    MOVLW   01H
    MOVWF   REG1
    BRA     CNT_01
CNTOPE
    CLRF    REG1
CNT_01
    MOVFF   FSR0L,F3SR  ; keep

    MOVLW   kiBSR
    MOVWF   FSR0H
    MOVFF   FSRCHN,FSR0L
    MOVF    INDF0,W
    ANDWF   CHSBIT,W
    BTFSS   STATUS,Z       ;  MADA SETTEN NON-on
    BRA     CTSJ0NK

    BTFSS   AAX,0
    BRA     CTSJ0NK

    CALL    BIB2CHK
    BTFSS   STATUS,Z
    BRA     CTSJ0NK        ; MAE  ON
CNT_02
    CALL    BYT2FC2     ; =>TMPL, TMPH
    BTFSS   REG1, 0
    CALL    BCDBIN        ; F1_SR FUSIYOU
CNT_03
    MOVLW   01            ; 1st -opera  contr
    MOVWF   FSR0H
    MOVFF   F3SR,FSR0L    ; kept
    CALL    WORDINC
    INCF    FSR0L,F
    MOVF    INDF0,W
    CPFSEQ  TMPH          ; skip if TMPH(l) ==INDF0
    BRA     CTSJ0NK

    DECF    FSR0L,F
    MOVF    INDF0,W
    CPFSEQ  TMPL        ; skip if TMPL ==INDF0
    BRA     CTSJ0NK
TCSET0ON
    MOVLW   kiBSR       ;BNK2
    MOVWF   FSR0H
    MOVFF   FSRCHN,FSR0L
    MOVF    INDF0,W
    IORWF   CHSBIT,W
    MOVWF   INDF0
CTSJ0NK
    CALL    STJOSET
    RETURN

;--------------------------------
RSTMOPE             ; ؾĥdr
    BTFSS   AAX,0
    RETURN

    MOVLW   3         ; BNK3
    MOVWF   FSR0H
    MOVFF   F1SR,FSR0L
    CLRF    POSTINC0
    CLRF    INDF0,0
    RETURN

RSTTOPE             ; ؾĥ
RSTCOPE             ; ؾĥ
    BTFSS   AAX,0
    RETURN

    MOVLW   kiBSR   ; BNK2
    MOVWF   FSR0H
    MOVFF   FSRCHN,FSR0L
    MOVF    INDF0,W,0
    COMF    CHSBIT,1
    ANDWF   CHSBIT,W
    MOVWF   INDF0
    FSR_FS2
    CLRF    POSTINC0
    CLRF    INDF0
    FSR_FS0
    RETURN

;----------------------------------------------------
MOVOPE
    BTFSS   AAX,0
    BRA     MOV_0R
    CALL    BYT2FC1        ; =>TMPL,TMPH
MOV_OP1
    CALL    BYT2PT2        ; TMPL->FSR""
MOV_0R
    RETURN

CMLOPE
    BTFSS   AAX,0
    RETURN

    CALL    BYT2FC1        ; =>TMPL,TMPH
    COMF    TMPL,F        ; MVN 
    COMF    TMPH,F
    BRA     MOV_OP1

;---------------------      -----------------------
MOVDOPE
    BTFSS   AAX,0
    RETURN

    CALL    BYT2FC1    ; =>TMPL,TMPH
    CALL    DADR_2CAL
    MOVF    TMPL,W
    FSR_FS2 
    MOVWF   INDF0
    FSR_FS0
    RETURN

;---------------------      -----------------------
MOVDPOPE
    CALL    BIB2CHK
    BTFSC   STATUS,Z
    CALL    MOVDOPE
    GOTO    STJOSET

;---------------------      -----------------------
NEGOPE
    BTFSS   AAX,0
    RETURN

    CALL    BYT2FC1        ; =>TMPL,TMPH
    MOVFF   FSR0L,FSR02L    ; 2nd operand@ƂANS
    MOVFF   FSR0H,FSR02H

    COMF    TMPL,1
    COMF    TMPH,1
    CLRF    FSR0H         ; BNK0
    MOVLW   TMPL
    MOVWF   FSR0L
    CALL    WORDINC
    BRA     MOV_OP1

XCHOPE
    BTFSS   AAX,0
    BRA     MOV_0R

    CALL    BYT2FC2        ; =>TMPL,TMPH
    MOVFF   TMPL,REG1
    MOVFF   TMPH,REG2      ; 2nd  keep

    CALL    MOVOPE        ; 1st ->2nd
    MOVFF   REG1,TMPL     ; kept
    MOVFF   REG2,TMPH
    CALL    BYT2PT1
    RETURN

;---------------        -----------------
MOVPOPE
    CALL    BIB2CHK
    BTFSC   STATUS,Z
    CALL    MOVOPE
    GOTO    STJOSET

CMLPOPE
    CALL    BIB2CHK
    BTFSC   STATUS,Z,0
    CALL    CMLOPE
    GOTO    STJOSET

NEGPOPE
    CALL    BIB2CHK
    BTFSC   STATUS,Z,0
    CALL    NEGOPE
    GOTO    STJOSET

XCHPOPE
    CALL    BIB2CHK
    BTFSC   STATUS,Z,0
    CALL    XCHOPE
    GOTO    STJOSET

;-------------           ---------------
BCDBIN                ; TMPL" ->TMPL"   BCD(9999) -> BIN  
    PUSH1_BSR
    banksel Q0H

    CLRF    Q5L
    CLRF    Q5H

    MOVLW   0E8h      ; 1000
    MOVWF   Q2L
    MOVLW   3h
    MOVWF   Q2H       ; TMPL" *Q2H,Q2L = Q4H,Q4L,Q3H,Q3L
    MOVoFWW TMPH
    ANDLW   0F0h
    MOVWF   Q1L
    SWAPF   Q1L,1     ; TMP_H  JOOI
    CLRF    Q1H
    CALL    MUL16B    ; Q1 *Q2 =(Q4,Q3)   mean *1000
    CALL    AD16Q35   ; Q3 +Q5 =Q5  STATUS,0    ;C

    MOVLW   64h       ; 100
    MOVWF   Q2L
    CLRF    Q2H
    MOVoFWW TMPH
    ANDLW   0Fh
    MOVWF   Q1L
    CLRF    Q1H
    CALL    MUL16B    ; Q1 *Q2 =(Q4,Q3)   mean *100
    CALL    AD16Q35   ; Q3 +Q5 =Q5  STATUS,0    ;C

    MOVLW   0Ah       ; 10
    MOVWF   Q2L
    CLRF    Q2H
    MOVoFWW TMPL
    ANDLW   0F0h
    MOVWF   Q1L
    SWAPF   Q1L,1     ; TMP_L  JOOI
    CLRF    Q1H
    CALL    MUL16B    ; mena *10
    CALL    AD16Q35   ; Q3 +Q5 =Q5  STATUS,0    ;C

    MOVoFWW TMPL
    ANDLW   0Fh
    MOVWF   Q3L
    CLRF    Q3H
    CALL    AD16Q35    ; Q3 +Q5 =Q5  STATUS,0    ;C

    MOVF    Q5L,W
    MOVoWFF TMPL
    MOVF    Q5H,W
    MOVoWFF TMPH

    POP1_BSR
    RETURN
;----------------------------------------------

AD16Q35                ; Q3" +Q5" =Q5"  _CRY
;   CLRF    Q6L
    PUSH2_BSR
    banksel Q0H

    CLRF    Q6H
    MOVF    Q5L,W
    ADDWF   Q3L,W
    MOVWF   Q6L
    BTFSC   STATUS,C
    INCF    Q6H,1
    MOVF    Q5H,W
    ADDWF   Q3H,W
    ADDWF   Q6H,1
    MOVF    Q6L,W
    MOVWF   Q5L
    MOVF    Q6H,W
    MOVWF   Q5H

    POP2_BSR
    RETURN            ; _CRY  MAMA  RET_URN

;------------------------------------------------
;                                       Q2H.Q2L
MUL16B            ; Q1 *Q2 =(Q4,Q3)     Q1H.Q1L
                  ;                    -----------
                  ;                     Q2L*Q1L      @
                  ;                 Q2H*Q1L@@@@@A  ʁAʂ2s
                  ;                 Q2L*Q1H@@@@@B  ʁAʂ2s
                  ;          +) Q2H*Q1H@@@@@@@C
                  ;            -------------------
                  ;          =  Q4H.Q4L.Q3H.Q3L
                  ;                  |   |
                  ;                 Q7H.Q7L         Jオ萔
    PUSH2_BSR
    banksel Q0H

    CLRF    Q7L
    CLRF    Q7H
                            ; ȉ1,24
    MOVF    Q1L,W
    MULWF   Q2L             ; @
    MOVFF   PRODL,Q3L       ; 1ڌ
    MOVFF   PRODH,Q3H
;    MOVF    Q1L,W
    MULWF   Q2H             ; A   ans.Ж
    MOVF    PRODL,W
    ADDWF   Q3H,F
    BNC     MB_01
    INCF    Q7L,F           ; Jオ萔 +1
MB_01
    MOVF    Q1H,W
    MULWF   Q2L             ; B
    MOVF    PRODL,W
    ADDWF   Q3H,F           ; 2ڌ
    BNC     MB_02
    INCF    Q7L,F           ; Jオ萔 +1
                            ; ȉ3,4
MB_02
    MOVFF   PRODH,Q4L       ; B   ans.
    MOVF    Q1L,W
    MULWF   Q2H             ; A   ans.Ж
    MOVF    PRODH,W
    ADDWF   Q4L,F           ; 3ڌ
    BNC     MB_03
    INCF    Q7H,F
MB_03
    MOVF    Q1H,W
    MULWF   Q2H             ; C
    MOVF    PRODL,W
    ADDWF   Q4L,W
    BNC     MB_04
    INCF    Q7H,F
MB_04
    ADDWF   Q7L,W
    BNC     MB_05
    INCF    Q7H,F
MB_05
    MOVWF   Q4L            ; 3ڌ
MB_06
    MOVF    PRODH,W
    ADDWF   Q7H,W
    MOVWF   Q4H            ; 4ڌ
    POP2_BSR
    RETURN

;----------------------------------------------
BINBCD          ; TMPL,TMPH ->Q0TP" ->TMPL,TMPH   BIN -> BCD( 9999 )
                ;|/  divisor=10000      Ɉʲ͐vZ->Q3L
    PUSH1_BSR
    banksel Q0H

    MOVFF   FSR0L,Q6L  ; keep
    MOVFF   FSR0H,Q6H
    MOVLW   10h        ; Q5@
    MOVWF   Q5L
    MOVLW   27h
    MOVWF   Q5H
                ;|/  for(i=0;i<5;++i) { 
    CLRF    Q0L       ; Q0 : i
    LFSR    0,ANSWER
    CLRF    POSTINC0
    CLRF    POSTINC0
    CLRF    INDF0     ; 5-KETA ME(  SARERU )  FSR0L equ ANSWER+2
BCD_CL
    MOVLW   05
    SUBWF   Q0L,W
    BTFSC   STATUS,C
    BRA     BCD_0R    ; OWARI 
                ;|/   digit = value/divisor; 
    MOVoFWW TMPH
    MOVWF   Q1H
    MOVoFWW TMPL
    MOVWF   Q1L
    MOVF    Q5H,W        ; Q5  => Q3
    MOVWF   Q3H
    MOVF    Q5L,W
    MOVWF   Q3L
    CALL    DIV16B       ;  Q1/Q3 =Q4...Q7
    MOVF    Q4L,W
    MOVWF   DIGIT        ;|/  value-=digit*divisor; 

    CLRF    Q1H
    MOVF    DIGIT,W
    MOVWF   Q1L
    MOVF    Q5H,W
    MOVWF   Q2H
    MOVF    Q5L,W
    MOVWF   Q2L
    CALL    MUL16B        ; Q1 *Q2 =Q4,Q3
    MOVF    Q3H,W
    MOVWF   Q4L           ;  Q4 =0
    MOVF    Q3L,W
    SUBoWFF TMPL
    MOVF    Q4L,W
    BTFSS   STATUS,C
    BRA     BINB_01
    BRA     BINB_02
BINB_01
    DECoFF  TMPH
BINB_02
    SUBoWFF TMPH
                    ;|/  divisor/=10; 
    MOVF    Q5H,W
    MOVWF   Q1H
    MOVF    Q5L,W
    MOVWF   Q1L
    CLRF    Q3H
    MOVLW   0Ah
    MOVWF   Q3L
    CALL    DIV16B        ; (Q1)/Q3 =Q4...Q7
    MOVF    Q4H,W
    MOVWF   Q5H
    MOVF    Q4L,W
    MOVWF   Q5L     ;  Q5" 10000->1000->100->10->1
                    ;|/  digit -> ANSWER
    BTFSC   Q0L,0            ; SAISHO ̈(Q0L ==0)  NON-SWAP
    SWAPF   DIGIT,1
    MOVF    DIGIT,W
    IORWF   INDF0,1
    BTFSS   Q0L,0            ; SAISHO ̈  DECF  FSR
                             ;>\ SWAP SITA ķ TSUGI ONAJI BYTE  KAI
    DECF    FSR0L,1
                    ;
    INCF    Q0L,1
    BRA     BCD_CL
BCD_0R
    MOVFF   ANSWER,TMPL
    MOVFF   ANSWER+1,TMPH
    MOVFF   ANSWER+2,Q3L
    MOVFF   Q6L,FSR0L       ; kept
    MOVFF   Q6H,FSR0H

    POP1_BSR
    RETURN

;------------------------------------------------
DIV16B                ; (Q2,Q1)/Q3 =Q4...Q7
                ;  Q2  always ==0       EX_DEC.LST 
    PUSH2_BSR
    banksel Q0H
    CLRF    Q4L
    CLRF    Q4H
    CLRF    Q2L
    CLRF    Q2H
    MOVF    Q3H,W
    BTFSS   STATUS,Z
    BRA     DIV_ST
    MOVF    Q3L,W
    BTFSC   STATUS,Z
    BRA     DIV_0R
DIV_ST
    MOVLW   10h
    MOVWF   Q0H
DIV_GR                ;@@@@@@@@@@@@@
    BCF     STATUS,C
    RLCF     Q1L,1
    RLCF     Q1H,1
    RLCF     Q2L,1
    RLCF     Q2H,1
    MOVF    Q3H,W
    SUBWF   Q2H,W
    BTFSS   STATUS,Z
    BRA     DIV_02
    MOVF    Q3L,W
    SUBWF   Q2L,W
DIV_02
    BTFSS   STATUS,C
    BRA     DIV_ANS
    MOVF    Q3L,W
    SUBWF   Q2L,1
    BTFSS   STATUS,C
    DECF    Q2H,1
    MOVF    Q3H,W
    SUBWF   Q2H,1
    BSF     STATUS,C
DIV_ANS
    RLCF     Q4L,1
    RLCF     Q4H,1
    DECFSZ  Q0H,1
    BRA     DIV_GR
DIV_0R
    MOVF    Q2L,W      ; ]]  AMARI
    MOVWF   Q7L        ; ]]
    MOVF    Q2H,W      ; ]]
    MOVWF   Q7H        ; ]]
    MOVF    Q4L,W
    IORWF   Q4H,W    ; łytǑ
    POP2_BSR
    RETURN

;------------- ȉ  CALCULATION  -----------------------
BCDBNFF               ; Q2L" ->Q2L   BCD(255) -> BIN  
    PUSH1_BSR
    banksel Q0H

    CLRF    Q0H
    MOVFF   Q2L,Q0L
    MOVF    Q2H,W
    BTFSC   STATUS,Z,0
    BRA     BCD_03
    DECF    Q2H,F
    BTFSS   STATUS,Z,0
    BRA     BCD_01
    MOVLW   064H      ; 3
    MOVWF   Q0H
    BRA     BCD_03
BCD_01
    MOVLW   0C8H
    MOVWF   Q0H      ; 3
BCD_03
    SWAPF   Q0L,W
    ANDLW   0FH      ; 2
    MOVWF   Q2H      ; keep
    BCF     STATUS,C,0
    RLCF    Q2H,W    ; *2
    ANDLW   1FH
    MOVWF   Q1L      ; keep
    MOVWF   Q1H
;   BCF     STATUS,C,0
    RLCF    Q1L,W    ; *2 mean *4
    MOVWF   Q1H
    RLCF    Q1H,W    ; *2 mean *8
;   BCF     STATUS,C,0
    ADDWF   Q1L,F      ;  *8 +*2 =*10
    MOVLW   0FH
    ANDWF   Q0L,W      ; 1
    ADDWF   Q1L,W
    ADDWF   Q0H,W      ; +3

    MOVWF   Q2L

    POP1_BSR
    RETURN

;----------------------------------------------
SUB16B                ; Q1 -Q2 =Q3  _CRY
    PUSH2_BSR         ; PUSH1 Ӷ
    banksel Q0H

;   CLRF    Q3L
    CLRF    Q3H
    MOVF    Q2L,W
    SUBWF   Q1L,W
    MOVWF   Q3L
    BTFSC   STATUS,C,0
    BRA     SU_01
    MOVF    Q1H,F
    BTFSC   STATUS,Z,0
    BRA     SU_02      ; Q1H  0
    DECF    Q1H,F    ; borrow ؂ė
    BRA     SU_01
SU_02
    DECF    Q1H,F    ;  W =>0FFH ļ ICHIOU calc
    MOVF    Q2H,W
    SUBWF   Q1H,W
    MOVWF   Q3H
    BCF     STATUS,C,0   ; Q1H  0 DATTA  _CRY=0( mean CRY  TATTA )
    IORWF   Q3L,W    ; łytǑ
    RETURN
SU_01
    MOVF    Q2H,W
    SUBWF   Q1H,W
    MOVWF   Q3H
    IORWF   Q3L,W    ; łytǑ

    POP2_BSR
    RETURN
;----------------------------------------------------

BK2_RET
    MOVLB   kiBSR
    RETURN

;----------------------------------------------------

WORDINC
    INCFSZ  INDF0,1
    BRA     WRD_INK

    INCF    FSR0L,1
    INCF    INDF0,1
    DECF    FSR0L,1
WRD_INK
    RETURN


BYTEINC
    COMF    INDF0,W
    BTFSC   STATUS,Z
    BRA     BYT_INK    ; 0xFF DATTARA NUKERU

    INCF    INDF0,F
BYT_INK
    MOVF    INDF0,W
    RETURN


WORDDEC
    DECF    INDF0,F
    INCFSZ  INDF0,W    ; 0xff DATTARA JOOI  dec
    BRA     WRD_D01
    INCF    FSR0L,F
    DECF    INDF0,F
    BRA     WRD_DNK
WRD_D01
    INCF    FSR0L,F
WRD_DNK
    RETURN

;---------------------      -----------------------
BIFCHK                     ;
    BSF     STATUS,Z       ; ؎0ST_JOSET
    GOTO    B01_CHK
;---------------------      -----------------------

BIBCHK                 ; KEKKA    Z =1  !pr
    BCF     STATUS,Z   ; ŏ  ؔŲ
B01_CHK
    BTFSC   INITMF,2
    RETURN
TMBB1CHK
    LFFSR2   BIBPONT, 0    
    FSR_FS2
    MOVF    INDF0,W
    FSR_FS0
    ANDWF   BIBBIT,W
    RETURN

;---------------------      -----------------------
BIB2CHK             ; 2nd -Opernds L  FSR1Hgpkeep
    BCF     STATUS,Z   ; ŏ  ؔŲ
    BTFSC   INITMF,2
    RETURN
TMBBCHK
    MOVFF   FSR02H,F2SR   ; keep  keepɶނȂdummy
    MOVFF   FSR02L,F1SR
    CLRF    FSR02H        ; BNK0
    MOVFF   BIBPONT,FSR02L ; FSR1L" USBޯނł͎gȂ
    FSR_FS2                ;>̂FSR02L"g
    MOVF    INDF0,W
    FSR_FS0
    ANDWF   BIBBIT,W
    MOVFF   F2SR,FSR02H   ; kept
    MOVFF   F1SR,FSR02L
    RETURN

;---------------------      -----------------------
STJOSET               ;  bnk2    bnk2׌Ă

    CLRF    FSR02H      ; BNK0(<=STJO-bnk)
    MOVFF   BIBPONT,FSR02L
    FSR_FS2
    MOVF    AAX,W          ; IIX ==1
    BTFSS   STATUS,Z
    BRA     SETJ01

    COMF    BIBBIT,F
    MOVF    INDF0,W        ; BANK 0
    ANDWF   BIBBIT,W
    BRA     SETJ02
SETJ01
    MOVF    INDF0,W        ; BANK 0
    IORWF   BIBBIT,W
SETJ02
    MOVWF   INDF0          ; BANK 0
;SETJ0R
    FSR_FS0
    RETURN                 ; ->BNK2 
;
;---------------------------------------------

INIRAM
    MOVLW   10h             ; AAX
    MOVWF   FSR0L
    MOVLW   00h
    MOVWF   FSR0H           ; BNK0
    CALL    CLRFFBY

    LFSR    0, TCRAM
    CALL    CLRFFBY

    LFSR    0, SETTN
    CALL    CLRFFBY

    LFSR    0, DMEM
    CALL    CLRFFBY

    LFSR    0, WMEM
    CALL    CLRFFBY

    RETURN


CLRFFBY
PO_03
    CLRF    POSTINC0,0
    MOVF    FSR0L, W
    BTFSS   STATUS, Z
    BRA     PO_03
    RETURN


TOKINI
    banksel TOKREG       ; BNK2
    MOVLW   0A0h
    MOVWF   TOKREG,1    ; ONE-SHOT ON
;   CLRF    TOKREG+1
    RETURN

;---------------              ------------------
CRY_SET                ; ADD ɰ
    PUSH1_BSR
    banksel TOKREG       ; BNK2
    BCF     TOKREG+1,6,1 ; preset
    BTFSC   STATUS,C,0
    BSF     TOKREG+1,6,1
    POP1_BSR
    RETURN

;------1>0  2>1  4>2  8>3  10h>4  20h>5  40h>6  80h>7---------
;BIT2SUU
;    MOVWF  Q0L
;    CLRF   TMPL
;    MOVLW  8
;    MOVWF  TMPH
;    MOVF   Q0L,F
;    BNZ    BITS_00
;    BRA    BITS_0R
;BITS_00
;    INCF   TMPL
;    RRCF   Q0L,F
;    BC     BITS_0R
;    DECFSZ TMPH,F
;    BRA    BITS_00
;    CLRF   TMPL     ; ]]]Ų
;BITS_0R
;    MOVF  TMPL,W
;    RETURN

;--------------------------------------------
MC1OPE              ; TMPH fetch
    BTFSS   AAX,0
    RETURN

MC_1
    DECFSZ TMPH,1   ; 100n
    BRA    MC_2     ; 200n
    RETURN
MC_2
    BRA    MC_3     ; 200n
MC_3
    NOP             ; 100n
    BRA    MC_4     ; 200n
MC_4
    BRA    MC_1     ; 200n


MC100OPE            ; TMPH fetch
    BTFSS   AAX,0
    RETURN
;
MC100_1                ; 100uS
    MOVLW   D'200'     ; 200*500n
    MOVWF   TMPL
MC100_2
    DECFSZ  TMPL,F     ; 100n
    BRA     MC100_5    ; 200n
    DECFSZ  TMPH,F
    BRA     MC100_1
    RETURN

MC100_5
    BRA     MC100_2    ; 200n

;--------------------------------------------
SFT150M             ; BNK0 MAWARU
    MOVLW   D'10'
    MOVWF   TMPH
SFT2_1
    CLRWDT
    CALL    SOFT15M
    DECFSZ  TMPH,F
    BRA     SFT2_1

    RETURN

;---------------------------------------------
SOFT15M
    MOVLW   D'150'
    MOVWF   TMP2
SOFT_100               ; 100uS
    MOVLW   D'200'        ; 200*500n
    MOVWF   TMPL
SOFT_2
    DECFSZ  TMPL,F     ; 100n
    BRA     SOFT_05    ; 200n
    DECFSZ  TMP2,F
    BRA     SOFT_100
    RETURN

SOFT_05
    BRA     SOFT_2     ; 200n

;---------------------------------------------
SOFT15N
    MOVLW   0FH
    MOVWF   TMPH
SO15_100               ; 100uS
    MOVLW   D'200'     ; 200*500n
    MOVWF   TMPL
SO15_2
    DECFSZ  TMPL,F     ; 100n
    BRA     SO15_05    ; 200n
    DECFSZ  TMPH,F
    BRA     SO15_100
 
    RETURN

SO15_05
    BRA     SO15_2     ; 200n


