;
;   Standard File

    list p=18F4550, r=dec

    include D:\YAMAHA\JAPAN\SRENRI\PIC\4550\p18F4550.inc

    include D:\YAMAHA\JAPAN\SRENRI\PIC\4550\HD8F550TP4.H

TRIARM    equ    0ffh
TRIBRM    equ    0e0h
TRICRM    equ    0cfh
TRIDRM    equ    0ffh
TRIERM    equ    0fh

TRIACO    equ    00h
TRIBCO    equ    01fh
TRICCO    equ    030h
TRIDCO    equ    00h
TRIECO    equ    0f0h

DIRCTA    equ    00h
DIRCTB    equ    00h
DIRCTC    equ    030h
DIRCTD    equ    00h
DIRCTE    equ    00h

DIRCOA    equ    0ffh
DIRCOB    equ    0ffh
DIRCOC    equ    0cfh
DIRCOD    equ    0ffh
DIRCOE    equ    0ffh

    global asm_int
    global pio_asm
    global ini_asm
    global seq_gr

    extern iniAndrF
    extern counter
;    extern conFlag
    extern DconF
    extern INPacket
    extern OUTPacket

         CODE
asm_int:
HIGH_PINT:
    MOVFF   PCLATH,PL0_TEMP
    MOVLB   0
TMR1_IM
    BCF     PIR1,TMR1IF
    MOVLW   0EEh        ; 2EEh =*4*8/48,000,000
    SUBWF   TMR1L, F    ;>> =0.0005S =0.5mS
    MOVLW   2
    BTFSS   STATUS, C
    MOVLW   3
    SUBWF   TMR1H, F
    INCF    CNT05M,F
    BTFSC   CNT05M,0
    BRA     JUSOX_KA
    INCF    COUNT1,F
    BNZ     TTM_01
    INCF    COUNT1 +1,F
TTM_01
SEG_I01
LCD_I01
JUSOX_KA
RI_C0R
HIGH_RET
    MOVFF   PL0_TEMP,PCLATH
    RETFIE  FAST

PON
;----------------------          ---------------------
ini_asm:
    CLRF    PORTA
    CLRF    PORTB
    CLRF    PORTC
    CLRF    PORTD
    CLRF    PORTE
                ;|/ ȉ@^C}[
    MOVLW   0Ch
    MOVWF   TMR1L ; 10000-FE0C =1F4 =500
    MOVLW   0FEh  ; (1/32MHZ)*4*8*500 =0.5mSECH
    MOVWF   TMR1H ;             |_T1CON

    CLRF    STATUS
    CLRF    INTCON
    CLRF    PIR1
    CLRF    CCPR1L  ; D/A-1
;    CLRF    CCPR2L ; D/A-2 def.=00(458Ų)
    CLRF    TBLPTRU
    CLRF    PCLATU

    BSF     RCON,IPEN
    CLRF    TMR2     ; ȉ PWMݒ
    MOVLW   01
    MOVWF   T2CON    ; prescale 4
    MOVLW   0FFH
    MOVWF   PR2


    BSF     PIE1,TMR1IE ; Enable TMR1 int
    BCF     IPR1,TMR1IP ; allways priority
    CLRF    T3CON

    MOVLW   34h ; pre-scale(TMR1) 1:8 <D5,4>
                ; NON-osilate NAIBU-clk
    MOVWF   T1CON
    BSF     T1CON,TMR1ON ; Turn Timer1 On

INI_SET
    CLRF    CCP1CON
    CLRF    CCP2CON

    MOVLW   0Fh
    MOVWF   ADCON1,0

    CALL    INIRAM
    CALL    TOKINI

    banksel USOTEX
    MOVLW   00h
    MOVWF   USOTEX
    MOVLW   00h
    MOVWF   USINEX

    MOVLW   01h
    MOVWF   NOMTMX
    MOVLW   0ffh
    MOVWF   delyTMX
    MOVLW   0dh
    MOVWF   INITMF
    banksel TUSEBIT
    MOVLW   02h
    MOVWF   TUSEBIT +D'0'
    banksel SETTN

    MOVLW   70H      ; HS_PLL 48MHz
    MOVWF   OSCCON   ; bit0,1 00  depend on CONFIG1H
    MOVLW   01
    MOVWF   IIX     ;@ IIXZbg

    RETURN

;----------------------          ---------------------
pio_asm
    CALL    SERL_USB
    RETURN
                    ; @@@@@@@@  ȍ~ BANK2
seq_gr
    banksel SETTN
    CALL    POT_INP ; ͐ړ_ SET_TN  
                    ; |/|/  -ݼٓ
    CLRF    LDLG                ; 1
    CLRF    AAX
    BTFSC   SETTNXY+00h,1
    BSF     AAX,0
    BTFSC   SETTN +00h,0
    BSF     AAX,0
    BTFSC   SETTNXY+00h,2
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   01H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 5
    CLRF    AAX
    BTFSC   SETTNXY+00h,2
    BSF     AAX,0
    BTFSC   SETTN +00h,1
    BSF     AAX,0
    BTFSC   SETTNXY+00h,1
    BCF     AAX,0
    BTFSC   SETTNXY+00h,3
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   02H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 10
    CLRF    AAX
    BTFSC   SETTNXY+00h,3
    BSF     AAX,0
    BTFSC   SETTN +00h,2
    BSF     AAX,0
    BTFSC   SETTNXY+00h,2
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   04H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 14
    CLRF    AAX
    BTFSC   RSETN +04h,0
    BSF     AAX,0
    BTFSC   SETTNXY+00h,1
    BCF     AAX,0
    BTFSC   SETTN +00h,3
    BSF     AAX,0
    BTFSC   SETTN +01h,1
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   08H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 19
    CLRF    AAX
    BTFSC   RSETN +00h,1
    BSF     AAX,0
    BTFSC   SETTNXY+00h,2
    BCF     AAX,0
    BTFSC   SETTN +00h,4
    BSF     AAX,0
    BTFSC   SETTN +01h,2
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   010H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 24
    CLRF    AAX
    BTFSC   RSETN +00h,5
    BSF     AAX,0
    BTFSC   SETTNXY+00h,3
    BCF     AAX,0
    BTFSC   SETTN +00h,5
    BSF     AAX,0
    BTFSC   SETTN +01h,3
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   020H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 29
    CLRF    AAX
    BTFSC   SETTN +00h,4
    BSF     AAX,0
    BTFSS   SETTNXY+00h,2
    BCF     AAX,0
    CALL    LOGINAX
    CLRF    AAX
    BTFSC   SETTN +00h,5
    BSF     AAX,0
    BTFSS   SETTNXY+00h,3
    BCF     AAX,0
    CALL    ORB
    BTFSC   SETTN +00h,6
    BSF     AAX,0
    BTFSS   SETTN +00h,7
    BCF     AAX,0
    CALL    LOGINAX
    CLRF    AAX
    BTFSC   SETTN +00h,4
    BSF     AAX,0
    BTFSS   SETTNXY+00h,2
    BCF     AAX,0
    CALL    LOGINAX
    CLRF    AAX
    BTFSC   SETTN +00h,3
    BSF     AAX,0
    BTFSS   SETTNXY+00h,1
    BCF     AAX,0
    CALL    ORB
    BTFSC   SETTN +00h,6
    BSF     AAX,0
    BTFSS   SETTN +01h,0
    BCF     AAX,0
    CALL    ORB
    BTFSC   TCSET+00h,1
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   040H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 46
    CLRF    AAX
    BTFSC   SETTN +00h,4
    BSF     AAX,0
    BTFSC   SETTN +00h,5
    BSF     AAX,0
    BTFSS   SETTN +00h,0
    BCF     AAX,0
    CALL    LOGINAX
    CLRF    AAX
    BTFSC   SETTN +00h,5
    BSF     AAX,0
    BTFSS   SETTN +00h,1
    BCF     AAX,0
    CALL    ORB
    BTFSC   SETTN +01h,0
    BCF     AAX,0
    LFSR    0,SETTN +00h
    MOVLW   080H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 54
    CLRF    AAX
    BTFSC   SETTN +00h,4
    BSF     AAX,0
    BTFSC   SETTN +00h,3
    BSF     AAX,0
    BTFSS   SETTN +00h,2
    BCF     AAX,0
    CALL    LOGINAX
    CLRF    AAX
    BTFSC   SETTN +00h,3
    BSF     AAX,0
    BTFSS   SETTN +00h,1
    BCF     AAX,0
    CALL    ORB
    BTFSC   SETTN +00h,7
    BCF     AAX,0
    LFSR    0,SETTN +01h
    MOVLW   01H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 62
    CLRF    AAX
    BTFSC   SETTN +00h,6
    BSF     AAX,0
    CLRF    REG1
    MOVLW   01H
    MOVWF   BIBBIT
    MOVLW   STJO +00H
    MOVWF   BIBPONT
    CALL    BBAXCH
    BTFSS   STATUS,Z
    RCALL   TM01
    CALL    STJOSET
    BRA     LABEL1
TM01
    LFSR    0,TCRAM+01h*2
    MOVLW   low OPRA2L
    MOVWF   FSR02L
    MOVLW   high OPRA2L
    MOVWF   FSR02H
    MOVLW   00h
    MOVWF   OPRA2L
    MOVLW   01h
    MOVWF   OPRA2H
    MOVLW   TCSET+0h
    MOVWF   FSRCHN
    MOVLW   02h
    MOVWF   CHSBIT
    GOTO    TIMOPE

LABEL1
    CLRF    LDLG                ; 64
    CLRF    AAX
    BTFSC   SETTN +00h,3
    BSF     AAX,0
    BTFSS   SETTNXY+00h,1
    BCF     AAX,0
    LFSR    0,SETTN +01h
    MOVLW   02H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 67
    CLRF    AAX
    BTFSC   SETTN +00h,4
    BSF     AAX,0
    BTFSS   SETTNXY+00h,2
    BCF     AAX,0
    LFSR    0,SETTN +01h
    MOVLW   04H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 70
    CLRF    AAX
    BTFSC   SETTN +00h,5
    BSF     AAX,0
    BTFSS   SETTNXY+00h,3
    BCF     AAX,0
    LFSR    0,SETTN +01h
    MOVLW   08H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 73
    CLRF    AAX
    BTFSC   SETTN +00h,7
    BSF     AAX,0
    BTFSC   SETTN +00h,6
    BCF     AAX,0
    BTFSC   SETTNXY+02h,1
    BCF     AAX,0
    LFSR    0,SETTNXY+02h
    MOVLW   01H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 77
    CLRF    AAX
    BTFSC   SETTN +01h,0
    BSF     AAX,0
    BTFSC   SETTN +00h,6
    BCF     AAX,0
    BTFSC   SETTNXY+02h,0
    BCF     AAX,0
    LFSR    0,SETTNXY+02h
    MOVLW   02H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 81
    CLRF    AAX
    BTFSC   SETTN +00h,0
    BSF     AAX,0
    LFSR    0,SETTNXY+02h
    MOVLW   04H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 83
    CLRF    AAX
    BTFSC   SETTN +00h,1
    BSF     AAX,0
    LFSR    0,SETTNXY+02h
    MOVLW   08H
    MOVWF   CHSBIT
    CALL    OUTOPE

    CLRF    LDLG                ; 85
    CLRF    AAX
    BTFSC   SETTN +00h,2
    BSF     AAX,0
    LFSR    0,SETTNXY+02h
    MOVLW   010H
    MOVWF   CHSBIT
    CALL    OUTOPE

    BTFSC   INITMF,2

    BRA     MAM_OUT

    CALL    STN_POT
    BRA     ITM_01
MAM_OUT
     MOVFF   SETTNXY +0*2,PORTA
     MOVFF   SETTNXY +1*2,PORTB
     MOVFF   SETTNXY +2*2,PORTC
     MOVFF   SETTNXY +3*2,PORTD
     MOVFF   SETTNXY +4*2,PORTE

;TRI_SET
    MOVLW   TRIARM
    MOVWF   TRISA
    MOVLW   TRIBRM
    MOVWF   TRISB
    MOVLW   TRICRM
    MOVWF   TRISC
    MOVLW   TRIDRM
    MOVWF   TRISD
    MOVLW   TRIERM
    MOVWF   TRISE
    MOVLW   7Fh
    ANDWF   TOKREG,F  ; 1 scan ON ܂
    BSF     INTCON,GIEH
    BSF     INTCON,GIEL
ITM_01
    banksel SETTN
TIM_WAT      ; BNK0 
    CLRWDT
    BCF     PIE1,TMR1IE ; DI TMR1 int
    MOVF    CONTKP,W
    SUBoWFW COUNT1
    MOVWF   KEITIM    ;  E0 -80  02 -EF 
    MOVF    CONTKP+1,W
    BC      TMW_01
    INCF    WREG,W      ; C =0 ->COUNT1 <CONTKP
TMW_01
    SUBoWFW COUNT1+1
    BSF     PIE1,TMR1IE ; EI TMR1 int
    MOVWF   KEITIM+1      ; ==TIMSA (*1mS)
    MOVLW   50
    CPFSLT  KEITIM
    BRA     TMW_02      ; 10 >= *
    MOVF    KEITIM+1,W
    BNZ     TMW_02
    BTFSC   INITMF,3    ; ݸ
    BRA     TIM_WAT     ; ^^^^^
TMW_02
    MOVFF   COUNT1,CONTKP
    MOVFF   COUNT1+1,CONTKP+1  ; Ol@keep
    CALL    TMR_01M    ; ϰZ

    BCF     INITMF,2

    RETURN               ;^^^^^^^^^^^^^^


STN_POT
    MOVF    SETTNXY +1*2,W
    ANDLW   DIRCOB
    IORWF   PORTB,F   ; 1 NARA 1 
    IORLW   DIRCTB
    ANDWF   PORTB,F   ; 0 NARA 0 
    MOVF    SETTNXY +2*2,W
    ANDLW   DIRCOC
    IORWF   PORTC,F   ; 1 NARA 1 
    IORLW   DIRCTC
    ANDWF   PORTC,F   ; 0 NARA 0 
    RETURN

    include D:\YAMAHA\JAPAN\SRENRI\PIC\4550\KIH8F550TP5.H
    include D:\YAMAHA\JAPAN\SRENRI\PIC\4550\BOPPUTP1.H
    include D:\YAMAHA\JAPAN\SRENRI\PIC\4550\Firmware\USBWIND10.H

        END
